SystemOrganization addCategory: #Temperature!

Object subclass: #Temperature
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Temperature'!

!Temperature commentStamp: 'FA 3/15/2013 20:19' prior: 0!
Represents a temperature value!

!Temperature methodsFor: 'converting' stamp: 'FA 3/20/2013 11:48'!
asCelsius

	|result|
	result:=TemperatureInCelsius new.
	result valueInKelvin:value.
	^ result! !

!Temperature methodsFor: 'converting' stamp: 'FA 3/20/2013 11:48'!
asFahrenheit

	|result|
	result:=TemperatureInFahrenheit new.
	result valueInKelvin:value.
	^ result! !

!Temperature methodsFor: 'converting' stamp: 'FA 3/20/2013 11:49'!
asKelvin

	|result|
	result:=TemperatureInKelvin new.
	result valueInKelvin:value.
	^ result! !

!Temperature methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:33'!
value

	^value! !

!Temperature methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:33'!
value: val

	value:=val! !

!Temperature methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:51'!
valueInKelvin: val

	value:=val! !

Temperature subclass: #TemperatureInCelsius
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Temperature'!

!TemperatureInCelsius commentStamp: 'FA 3/15/2013 20:19' prior: 0!
Represents a temperature value in Celsius!

!TemperatureInCelsius methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:42'!
value

	^ value - 273.15! !

!TemperatureInCelsius methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:42'!
value: val

	value:=val+273.15.
	^ val! !

Temperature subclass: #TemperatureInFahrenheit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Temperature'!

!TemperatureInFahrenheit commentStamp: 'FA 3/15/2013 20:20' prior: 0!
Represents temperature value in Fahrenheit!

!TemperatureInFahrenheit methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:45'!
value

	^ value*1.8 - 459.67! !

!TemperatureInFahrenheit methodsFor: 'accessing' stamp: 'FA 3/15/2013 19:44'!
value: val

	value:=val+459.67/1.8.
	^val! !

Temperature subclass: #TemperatureInKelvin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Temperature'!

!TemperatureInKelvin commentStamp: 'FA 3/15/2013 20:20' prior: 0!
Represents temperature value in Kelvin!

!TemperatureInKelvin methodsFor: 'accessing' stamp: 'tgn 5/10/2013 17:47'!
value
	^ value*10! !
